﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace UltraGridCustomColumnChooserOrder
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = InitializeGridDataSource(10);
            ultraGrid1.BeforeColumnChooserDisplayed += new Infragistics.Win.UltraWinGrid.BeforeColumnChooserDisplayedEventHandler(ultraGrid1_BeforeColumnChooserDisplayed);
        }

        private void ultraGrid1_BeforeColumnChooserDisplayed(object sender, Infragistics.Win.UltraWinGrid.BeforeColumnChooserDisplayedEventArgs e)
        {
            UltraGrid grid = (UltraGrid)e.Dialog.Controls[0].Controls[0];
            grid.InitializeLayout += new InitializeLayoutEventHandler(grid_InitializeLayout);
        }

        private void grid_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {      
            e.Layout.Bands[0].SortedColumns.Add(e.Layout.Bands[0].Columns[2], descending: true);
        }

        private DataTable InitializeGridDataSource(int rows)
        {
            DataTable table = new DataTable("Table1");

            table.Columns.Add("A column", typeof(Boolean));
            table.Columns.Add("B column", typeof(Int32));
            table.Columns.Add("C column", typeof(DateTime));
            table.Columns.Add("D column", typeof(int));

            for (int index = 0; index < rows; index++)
            {
                DataRow row = table.NewRow();
                row["A column"] = index % 2 == 0 ? true : false;
                row["B column"] = index;
                row["C column"] = DateTime.Now;
                row["D column"] = 0;
                table.Rows.Add(row);
            }

            return table;
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {

            ultraGrid1.ShowColumnChooser(true);
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {
            ColumnsCollection collection = ultraGrid1.DisplayLayout.Bands[0].Columns;
            collection[0].Header.VisiblePosition = 2;
        }
    }
}